//DinMaColor
//---- indicator settings
#property indicator_chart_window
#property  indicator_buffers 6
#property  indicator_color1  Gold
#property  indicator_color2  LimeGreen
#property  indicator_color3  Red
#property  indicator_color4  Gold
#property  indicator_color5  DarkGreen
#property  indicator_color6  Magenta
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2
//--- input parameters
extern int Period_main=10,
           Period_plus=20,
           ma_base=7,
           ma_method,
           applied_price;
extern double FlatPoints=0.99;
//---- indicator buffers
double ExtBuffer0[],ExtBuffer1[],ExtBuffer2[],
       ExtBuffer3[],ExtBuffer4[],ExtBuffer5[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//DinMaColor(dimeon),   Martingeil
//                  ,    tara
//  
//double din_up = iCustom(Symbol(),0,"DinMaColor",Period_main,Period_plus,1,1):
//if (din_up != EMPTY_VALUE){up=1;}// ,  .
int init()
  {
   IndicatorBuffers(6); 
   //---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexStyle(5,DRAW_LINE);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- 3 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);
   SetIndexBuffer(3,ExtBuffer3);
   SetIndexBuffer(4,ExtBuffer4);
   SetIndexBuffer(5,ExtBuffer5);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("DinMaColor");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| DinMa                                                            |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   double ma_main,ma_plus;
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
//---- ma
   for(int i=0; i<limit; i++)
   {
    ma_main= iMA(NULL,0,Period_main,0,ma_method,applied_price,i);
    ma_plus= iMA(NULL,0,Period_plus,0,ma_method,applied_price,i);
    ExtBuffer0[i]=ma_main-ma_plus;
    switch(ma_base)
    {
     case PRICE_CLOSE:
     {
      ExtBuffer0[i]+=Close[i];
      break;
     }
     case PRICE_OPEN:
     {
      ExtBuffer0[i]+=Open[i];
      break;
     }
     case PRICE_HIGH:
     {
      ExtBuffer0[i]+=High[i];
      break;
     }
     case PRICE_LOW:
     {
      ExtBuffer0[i]+=Low[i];
      break;
     }
     case PRICE_MEDIAN:
     {
      ExtBuffer0[i]+=0.5*(High[i]+Low[i]);
      break;
     }
     case PRICE_TYPICAL:
     {
      ExtBuffer0[i]+=(High[i]+Low[i]+Close[i])/3;
      break;
     }
     case PRICE_WEIGHTED:
     {
      ExtBuffer0[i]+=0.25*(High[i]+Low[i]+2*Close[i]);
      break;
     }
     default:
      ExtBuffer0[i]+=ma_main;
    }
    ExtBuffer1[i]=EMPTY_VALUE;
    ExtBuffer2[i]=EMPTY_VALUE;
    ExtBuffer3[i]=ma_main;
    ExtBuffer4[i]=EMPTY_VALUE;
    ExtBuffer5[i]=EMPTY_VALUE;
    if(ma_main-ma_plus>FlatPoints*Point)
    {
     ExtBuffer4[i]=ExtBuffer3[i];
     ExtBuffer5[i]=EMPTY_VALUE;
    }
    if(ma_main-ma_plus<FlatPoints*Point)
    {
     ExtBuffer5[i]=ExtBuffer3[i];
     ExtBuffer4[i]=EMPTY_VALUE;
    }
    if(i==0) continue;
    //---- dispatch values between 2 buffers
    if(ExtBuffer0[i-1]-ExtBuffer0[i]>FlatPoints*Point)
    {
     ExtBuffer1[i-1]=ExtBuffer0[i-1];
     ExtBuffer2[i-1]=EMPTY_VALUE;
    }
    if(ExtBuffer0[i-1]-ExtBuffer0[i]<FlatPoints*Point)
    {
     ExtBuffer2[i-1]=ExtBuffer0[i-1]; 
     ExtBuffer1[i]=EMPTY_VALUE;
    }   
   }
//---- done
return(0);}
//--------------------------------------------------------------------------------------------------